package jp.veltec.pdf;

import com.lowagie.text.*;			//iTextgAPI
import com.lowagie.text.pdf.*;		//iTextgAPI
import org.w3c.dom.*;
import org.w3c.dom.Element;
import java.util.HashMap;

class PdfTableWrapper{
	private PdfPTable table;
	private Element eleTable;
	private HashMap<String,String> hmValues;

	private int intCols;
	private int intRows;
	private int intColCounter;
	private int intRowCounter;
	private float fltOuterBorderWidth=1f;

	public void setElement(Element element){
		this.eleTable=element;
	}

	void setValues(HashMap<String,String> values){
		this.hmValues=values;
	}

	PdfPTable getTable() throws Exception{
		String strAttr;

		//-------------cols------------
		strAttr = this.eleTable.getAttribute("cols");
		int intCols=1;
		if(!strAttr.equals("")){
			intCols=Integer.parseInt(strAttr);
		}else{
			throw new Exception("table ^O cols w肳Ă܂B");
		}
		this.table = new PdfPTable(intCols);
		this.intCols=intCols;

		//-------------widths------------
		float[] aryFltWidths = new float[intCols];
		strAttr=this.eleTable.getAttribute("widths");
		if(!strAttr.equals("")){
			String[] aryStrWidths = strAttr.split(" ");
			try{
				for(int i=0;i<intCols;i++){
					aryFltWidths[i]=Float.parseFloat(aryStrWidths[i]);
				}
			}catch(Exception e){
				throw new Exception("widths ̎w肪Ⴂ܂BlXy[Xŋ؂Ďw肵ĂB");
			}
		}else{
			throw new Exception("table ^O widths w肳Ă܂B");
		}
		this.table.setWidths(aryFltWidths);

		//-------------total-width------------
		float fltTotalWidth=100f;
		strAttr = this.eleTable.getAttribute("total-width");
		if(!strAttr.equals("")){
			if(strAttr.endsWith("%")){
				fltTotalWidth = Float.parseFloat(strAttr.substring(0,strAttr.length()-1));
			}
		}
		this.table.setWidthPercentage(fltTotalWidth);

		//-------------outer-border-width------------
		strAttr = this.eleTable.getAttribute("outer-border-width");
		if(!strAttr.equals("")){
			this.fltOuterBorderWidth = PdfUtil.getSize(strAttr);
		}

		//-------------margin------------
		strAttr = this.eleTable.getAttribute("margin-top");
		if(!strAttr.equals("")){
			this.table.setSpacingBefore(PdfUtil.getSize(strAttr));
		}

		strAttr = this.eleTable.getAttribute("margin-bottom");
		if(!strAttr.equals("")){
			this.table.setSpacingAfter(PdfUtil.getSize(strAttr));
		}

		//-------- set default cell -----
		PdfCellWrapper cellTableDefault = new PdfCellWrapper();
		cellTableDefault.setAttributes(eleTable.getAttributes());

		//-------- process tr --------
		NodeList nlRow = this.eleTable.getElementsByTagName("tr");
		this.intRows=nlRow.getLength();
		this.intRowCounter=0;		//
		for(int i=0;i<this.intRows;i++){
			PdfCellWrapper cellRowDefault = cellTableDefault.getCopy();
			processRow((Element)nlRow.item(i),cellRowDefault);
		}
		return this.table;
	}

	void processRow(Element eleRow,PdfCellWrapper cellRowDefault) throws Exception{
		cellRowDefault.setAttributes(eleRow.getAttributes());
		NodeList nlColumn = eleRow.getElementsByTagName("td");
		this.intRowCounter++;
		this.intColCounter=0;			//
		for(int i=0;i<nlColumn.getLength();i++){
			PdfCellWrapper cellColumnDefault = cellRowDefault.getCopy();
			processColumn((Element)nlColumn.item(i),cellColumnDefault);
		}
	}

	void processColumn(Element eleColumn,PdfCellWrapper cell) throws Exception{
		cell.setAttributes(eleColumn.getAttributes());
		String strAttr=eleColumn.getAttribute("colspan");
		int intColspan=1;
		if(!strAttr.equals("")){
			intColspan=Integer.parseInt(strAttr);
			cell.setColspan(intColspan);
		}
		if(this.intColCounter==0) cell.setBorderWidthLeft(this.fltOuterBorderWidth);
		this.intColCounter += intColspan;
		if(this.intColCounter==intCols) cell.setBorderWidthRight(this.fltOuterBorderWidth);
		if(this.intRowCounter==1) cell.setBorderWidthTop(this.fltOuterBorderWidth);
		if(this.intRowCounter==intRows) cell.setBorderWidthBottom(this.fltOuterBorderWidth);

		String strContent=eleColumn.getTextContent();
		strAttr=eleColumn.getAttribute("id");
		if(!strAttr.equals("") && this.hmValues!=null){
			String strValue = hmValues.get(strAttr);
			if(strValue!=null){
				strContent=strValue;
			}
		}
		cell.setString(strContent);
		this.table.addCell(cell);
	}

}