package jp.veltec.pdf;

import com.lowagie.text.Element;
import java.awt.Color;

public class PdfUtil{
	public static final float fltM2P = 83f*12/350;

	public static float getSize(String size) throws Exception{
		float fltResult=0;
		if(size.endsWith("pt")){
			fltResult=Float.parseFloat(size.substring(0,size.length()-2));
		}else if(size.endsWith("mm")){
			fltResult=Float.parseFloat(size.substring(0,size.length()-2))*fltM2P;
		}else{
			throw new Exception("size format error");
		}
		return fltResult;
	}

	public static Color getColor(String color){
		int r =Integer.valueOf(color.substring(1,3),16);
		int g =Integer.valueOf(color.substring(3,5),16);
		int b =Integer.valueOf(color.substring(5,7),16);
		return new Color(r,g,b);
	}

	public static int getAlign(String str) throws Exception{
		int intResult=0;
		if(str.equals("left")){
			intResult = Element.ALIGN_LEFT;
		}else if(str.equals("right")){
			intResult = Element.ALIGN_RIGHT;
		}else if(str.equals("center")){
			intResult = Element.ALIGN_CENTER;
		}else if(str.equals("top")){
			intResult = Element.ALIGN_TOP;
		}else if(str.equals("bottom")){
			intResult = Element.ALIGN_BOTTOM;
		}else if(str.equals("middle")){
			intResult = Element.ALIGN_MIDDLE;
		}else{
			throw new Exception("align not match");
		}
		return intResult;
	}
}
